package de.hsbo.fbv.bmg.vectors.aufgaben;

/**
 * 
 * @author zimmermann
 *
 */
public class Line {
	
	// Attribute
	Coordinate c0 = null;
	Coordinate c1 = null;
	
	/**
	 * Konstruktor
	 * @param c0
	 * @param c1
	 */
	public Line(Coordinate c0, Coordinate c1) throws Exception {
		
		if (c0.getDimension()==c1.getDimension()) {
			this.c0 = c0;
			this.c1 = c1;
		}
		else
			throw new Exception("Coordinates must have same dimensions!");
	}
	
	/**
	 * Berechnet einen Punkt auf der Geraden.
	 * @param lambda
	 * @return
	 */
	public Coordinate getCoordinate(double lambda) {
		try {
			return Coordinate.create((c0.mul(1-lambda)).add(c1.mul(lambda)));
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}
	
	/**
	 * Berechnet den Abstand eines Punktes von der Geraden
	 * @param c
	 * @return
	 */
	public double getDistance(Coordinate c) {
		// TODO
		return Double.NaN;
	}
	
	public double getLength() {
		// TODO
		return Double.NaN;		
	}

	public double getLength(double t) {
		// TODO
		return Double.NaN;		
	}

	public double getLength(double ts, double te) {
		// TODO
		return Double.NaN;		
	}

}
