package de.hsbo.fbv.bmg.vectors.demos;

import de.hsbo.fbv.bmg.vectors.Vector;

/**
 * Demo-Programm, das die Verwendung der Klasse Vektor zeigt.
 * @author A.Zimmermann, HS Bochum, 2011
 *
 */
public class VectorSample {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Vector v = new Vector(new double[] {1,1});
		System.out.println("Vektor v: \t"+v);
		System.out.println("Lnge v:  \t"+v.length());
		System.out.println("Orthog. v:\t"+v.ortho());
		
		Vector p = new Vector(new double[] {2,2});
		System.out.println("Vektor p: \t"+p);
		
		System.out.println("Summe:    \t"+v.add(p));
		System.out.println("Differenz:\t"+v.sub(p));
		System.out.println("Skalarprodukt:\t"+v.mul(p));
		System.out.println("Vektorprodukt:\t"+v.vprod(p));
		
		
	}

}
